IconInputControl = class(Turbine.UI.Control)
function IconInputControl:Constructor(parent, width, y, args)
    Turbine.UI.Control.Constructor(self)
    self.width = width
    self.height = 52
    self.number = number

    self:SetParent(parent)
    self:SetSize(self.width, 52)
    self:SetPosition(0, y)
    self:SetMouseVisible(false)
    --self:SetBackColor(Turbine.UI.Color.Black)

    self.innerBlock = Turbine.UI.Control()
    self.innerBlock:SetParent(self)
    self.innerBlock:SetSize(self.width, 50)
    self.innerBlock:SetPosition(1, 1)
    --self.innerBlock:SetBackColor(Turbine.UI.Color(0.01,0.31,0.31))

    self.label = Turbine.UI.Label()
    self.label:SetParent(self.innerBlock)
    self.label:SetSize(150, 20)
    self.label:SetPosition(0, 2)
    self.label:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.label:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.label:SetOutlineColor(Turbine.UI.Color.Black)
    self.label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft)
    self.label:SetText(args.Text)
    
    self.EffectTimerIconBox = Turbine.UI.Control()
    self.EffectTimerIconBox:SetParent(self.innerBlock)
    self.EffectTimerIconBox:SetPosition(0, 20)
    self.EffectTimerIconBox:SetSize(32,32)
    self.EffectTimerIconBox:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend)
    self.EffectTimerIconBox:SetBackground(tonumber(args.Value) or args.Value or 1090551617)
    --self.EffectTimerIconBox:SetBackColor(Turbine.UI.Color.Black)
    self.EffectTimerIconBox:SetVisible(true)

    self.TimerIconTextBox = Turbine.UI.Lotro.TextBox()
    self.TimerIconTextBox:SetParent(self.innerBlock)
    self.TimerIconTextBox:SetSize(width - 40, 20)
    self.TimerIconTextBox:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.TimerIconTextBox:SetFont(Turbine.UI.Lotro.Font.BookAntiquaBold18)
    self.TimerIconTextBox:SetMouseVisible(false)
    self.TimerIconTextBox:SetPosition(40, 23)
    self.TimerIconTextBox:SetMultiline(false)
    self.TimerIconTextBox:SetText(args.Value)

    self.ChangeButton = UI.Button()
    self.ChangeButton:SetParent(self.innerBlock)
    self.ChangeButton:SetText("Change")
    self.ChangeButton:SetSize(60, 20)
    self.ChangeButton:SetPosition(width - 60, 0)

    self.ChangeButton.Click = function()
        if not _G.IconOverview then
            _G.IconOverview  = Data.SimpleIconOverview()
        end

        _G.IconOverview:SetVisible(true) 
        _G.IconOverview:Register(self.EffectTimerIconBox, self.TimerIconTextBox)
    end

    self.EffectTimerIconBox.MouseClick = function()
        if not _G.IconOverview then
            _G.IconOverview  = Data.SimpleIconOverview()
        end

        _G.IconOverview:SetVisible(true) 
        _G.IconOverview:Register(self.EffectTimerIconBox, self.TimerIconTextBox)
    end

    self.EffectTimerIconBox.MouseDoubleClick = function()
        self.EffectTimerIconBox:SetBackground(BackgroundHandler:GetBackground(0x41007F41))
        self.TimerIconTextBox:SetText(0x41007F41)
    end

    self.TimerIconTextBox.TextChanged = function()
        self:ValueChanged()
    end

    self.SizeChanged = function ()
        self.width = self:GetWidth()
        self:Format()
    end
end

function IconInputControl:Format()
    self.innerBlock:SetSize(self.width, self.height)
end

function IconInputControl:GetValue()
    return self.TimerIconTextBox:GetText()
end

function IconInputControl:ValueChanged()

end

function IconInputControl:SetValue(value)
    self.TimerIconTextBox:SetText(tostring(value))
end

function IconInputControl:Unload()
    self.label:SetParent(nil)
    self.innerBlock:SetParent(nil)
    self.TimerIconTextBox:SetParent(nil)
    self.EffectTimerIconBox:SetParent(nil)
    self.Button:SetParent(nil)
    local controlList = self:GetControls()
    for i = 1, controlList:GetCount() do
        controlList:RemoveAt(1)
    end
    for key, _ in pairs(self) do
        self[key] = nil
    end
end