Button = class(Turbine.UI.Control)
function Button:Constructor()
    Turbine.UI.Control.Constructor(self)

    self.width = 200
    self.height = 20
    self.borderSize = 2

    self:SetVisible(true)
    self:SetPosition(0, 0)
    self:SetMouseVisible(true)
    self:SetBackColor(Turbine.UI.Color.White)

    self.innerBackground = Turbine.UI.Label()
    self.innerBackground:SetParent(self)
    self.innerBackground:SetPosition(self.borderSize, self.borderSize)
    self.innerBackground:SetBackColor(Turbine.UI.Color.Teal)
    self.innerBackground:SetSize(self:GetWidth() - 2 * self.borderSize, self:GetHeight() - 2 * self.borderSize)
    self.innerBackground:SetFont(Turbine.UI.Lotro.Font.FixedSys15)
    self.innerBackground:SetFontStyle(Turbine.UI.FontStyle.Outline)
    self.innerBackground:SetOutlineColor(Turbine.UI.Color.Black)
    self.innerBackground:SetForeColor(Turbine.UI.Color.White)
    self.innerBackground:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleCenter)
    self.innerBackground:SetMouseVisible(false)

    self.MouseClick = function()
        if self.Click then
            self:Click()
        end
    end

    self.MouseEnter = function()
        self.innerBackground:SetBackColor(Turbine.UI.Color.DarkSlateGray)
    end

    self.MouseLeave = function()
        self.innerBackground:SetBackColor(Turbine.UI.Color.Teal)
    end

    self.SizeChanged = function()
        self.width = self:GetWidth()
        self.height = self:GetHeight()
        self:Format()
    end
    
    self:SetSize(self.width, self.height)
    self:Format()
end

function Button:Format()
    --self:SetSize(self.width, self.height)
    self.innerBackground:SetPosition(self.borderSize, self.borderSize)
    self.innerBackground:SetSize(self:GetWidth() - 2 * self.borderSize, self:GetHeight() - 2 * self.borderSize)
end

function Button:SetBorderWidth(width)
    self.borderSize = width or 2
    self:Format()
end

function Button:SetButtonSize(width, height)
    self.width = width or 200
    self.height = height or 20
    self:Format()
end

function Button:SetText(text)
    self.innerBackground:SetText(text or "")
    self:Format()
end

function Button:SetFont(font)
    self.innerBackground:SetFont(font)
end

function Button:Click()

end